# ncurses 6.0 - patch 20170916 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.0 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.0 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.0
#	http://invisible-mirror.net/archives/ncurses/6.0 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.0/ncurses-6.0-20170916.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Sep 17 00:11:40 UTC 2017
# ------------------------------------------------------------------------------
# NEWS                             |    6 +++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# man/curs_util.3x                 |   23 ++++++++++++++++++-----
# ncurses/base/lib_set_term.c      |   20 +++++++++++++-------
# ncurses/tinfo/tinfo_driver.c     |   22 ++++++++++++++--------
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# test/filter.c                    |    4 ++--
# 13 files changed, 65 insertions(+), 36 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.2949 
--- ncurses-6.0-20170909+/NEWS	2017-09-09 22:32:34.000000000 +0000
+++ ncurses-6.0-20170916/NEWS	2017-09-11 21:43:24.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2949 2017/09/09 22:32:34 tom Exp $
+-- $Id: NEWS,v 1.2951 2017/09/11 21:43:24 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,10 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20170916
+	+ minor fix to test/filter.c to avoid clearing the command in one case.
+	+ modify filter() to discard clr_eos if back_color_erase is set.
+
 20170909
 	+ improve wide-character implementation of myADDNSTR() in frm_driver.c,
 	  which was inconsistent with the normal implementation.
Index: VERSION
--- ncurses-6.0-20170909+/VERSION	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/VERSION	2017-09-10 17:21:32.000000000 +0000
@@ -1 +1 @@
-5:0:9	6.0	20170909
+5:0:9	6.0	20170916
Index: dist.mk
Prereq:  1.1182 
--- ncurses-6.0-20170909+/dist.mk	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/dist.mk	2017-09-10 17:21:32.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1182 2017/09/03 20:54:16 tom Exp $
+# $Id: dist.mk,v 1.1183 2017/09/10 17:21:32 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 0
-NCURSES_PATCH = 20170909
+NCURSES_PATCH = 20170916
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: man/curs_util.3x
Prereq:  1.49 
--- ncurses-6.0-20170909+/man/curs_util.3x	2017-05-30 21:09:21.000000000 +0000
+++ ncurses-6.0-20170916/man/curs_util.3x	2017-09-10 21:20:35.000000000 +0000
@@ -27,7 +27,7 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: curs_util.3x,v 1.49 2017/05/30 21:09:21 tom Exp $
+.\" $Id: curs_util.3x,v 1.50 2017/09/10 21:20:35 tom Exp $
 .TH curs_util 3X ""
 .ie \n(.g .ds `` \(lq
 .el       .ds `` ``
@@ -124,10 +124,23 @@
 .PP
 The \fBfilter\fR routine, if used, must be called before \fBinitscr\fR or
 \fBnewterm\fR are called.
-The effect is that, during those calls, \fBLINES\fR
-is set to 1; the capabilities \fBclear\fR, \fBcup\fR, \fBcud\fR, \fBcud1\fR,
-\fBcuu1\fR, \fBcuu\fR, \fBvpa\fR are disabled; and the \fBhome\fR string is
-set to the value of \fBcr\fR.
+Calling \fBfilter\fP causes these changes in initialization:
+.bP
+\fBLINES\fR is set to 1;
+.bP
+the capabilities
+\fBclear\fR,
+\fBcud1\fR,
+\fBcud\fR,
+\fBcup\fR,
+\fBcuu1\fR,
+\fBcuu\fR,
+\fBvpa\fR
+are disabled;
+.bP
+the capability \fBed\fP is disabled if \fBbce\fP is set;
+.bP
+and the \fBhome\fR string is set to the value of \fBcr\fR.
 .PP
 The \fBnofilter\fP routine cancels the effect of a preceding \fBfilter\fP
 call.
Index: ncurses/base/lib_set_term.c
Prereq:  1.166 
--- ncurses-6.0-20170909+/ncurses/base/lib_set_term.c	2017-07-01 16:37:24.000000000 +0000
+++ ncurses-6.0-20170916/ncurses/base/lib_set_term.c	2017-09-10 21:09:16.000000000 +0000
@@ -46,7 +46,7 @@
 #undef CUR
 #define CUR SP_TERMTYPE
 
-MODULE_ID("$Id: lib_set_term.c,v 1.166 2017/07/01 16:37:24 tom Exp $")
+MODULE_ID("$Id: lib_set_term.c,v 1.167 2017/09/10 21:09:16 tom Exp $")
 
 #ifdef USE_TERM_DRIVER
 #define MaxColors      InfoOf(sp).maxcolors
@@ -369,13 +369,19 @@
 #ifdef USE_TERM_DRIVER
 	CallDriver(sp, td_setfilter);
 #else
-	clear_screen = 0;
-	cursor_down = parm_down_cursor = 0;
-	cursor_address = 0;
-	cursor_up = parm_up_cursor = 0;
-	row_address = 0;
+	/* *INDENT-EQLS* */
+	clear_screen     = ABSENT_STRING;
+	cursor_address   = ABSENT_STRING;
+	cursor_down      = ABSENT_STRING;
+	cursor_up        = ABSENT_STRING;
+	parm_down_cursor = ABSENT_STRING;
+	parm_up_cursor   = ABSENT_STRING;
+	row_address      = ABSENT_STRING;
+	cursor_home      = carriage_return;
+
+	if (back_color_erase)
+	    clr_eos = ABSENT_STRING;
 
-	cursor_home = carriage_return;
 #endif
 	T(("filter screensize %dx%d", slines, scolumns));
     }
Index: ncurses/tinfo/tinfo_driver.c
Prereq:  1.58 
--- ncurses-6.0-20170909+/ncurses/tinfo/tinfo_driver.c	2017-06-26 00:43:07.000000000 +0000
+++ ncurses-6.0-20170916/ncurses/tinfo/tinfo_driver.c	2017-09-10 21:08:46.000000000 +0000
@@ -51,7 +51,7 @@
 # endif
 #endif
 
-MODULE_ID("$Id: tinfo_driver.c,v 1.58 2017/06/26 00:43:07 tom Exp $")
+MODULE_ID("$Id: tinfo_driver.c,v 1.59 2017/09/10 21:08:46 tom Exp $")
 
 /*
  * SCO defines TIOCGSIZE and the corresponding struct.  Other systems (SunOS,
@@ -213,7 +213,7 @@
     _nc_free_termtype2(&TerminalType(termp))
 #endif
 
-	if (generic_type) {
+    if (generic_type) {
 	/*
 	 * BSD 4.3's termcap contains mis-typed "gn" for wy99.  Do a sanity
 	 * check before giving up.
@@ -1024,12 +1024,18 @@
 {
     AssertTCB();
 
-    clear_screen = 0;
-    cursor_down = parm_down_cursor = 0;
-    cursor_address = 0;
-    cursor_up = parm_up_cursor = 0;
-    row_address = 0;
-    cursor_home = carriage_return;
+    /* *INDENT-EQLS* */
+    clear_screen     = ABSENT_STRING;
+    cursor_address   = ABSENT_STRING;
+    cursor_down      = ABSENT_STRING;
+    cursor_up        = ABSENT_STRING;
+    parm_down_cursor = ABSENT_STRING;
+    parm_up_cursor   = ABSENT_STRING;
+    row_address      = ABSENT_STRING;
+    cursor_home      = carriage_return;
+
+    if (back_color_erase)
+	clr_eos = ABSENT_STRING;
 }
 
 static void
Index: package/debian-mingw/changelog
--- ncurses-6.0-20170909+/package/debian-mingw/changelog	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/package/debian-mingw/changelog	2017-09-10 17:21:32.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170909) unstable; urgency=low
+ncurses6 (6.0+20170916) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 03 Sep 2017 16:54:16 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 10 Sep 2017 13:21:32 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.0-20170909+/package/debian-mingw64/changelog	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/package/debian-mingw64/changelog	2017-09-10 17:21:32.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170909) unstable; urgency=low
+ncurses6 (6.0+20170916) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 03 Sep 2017 16:54:16 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 10 Sep 2017 13:21:32 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.0-20170909+/package/debian/changelog	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/package/debian/changelog	2017-09-10 17:21:32.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20170909) unstable; urgency=low
+ncurses6 (6.0+20170916) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 03 Sep 2017 16:54:16 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 10 Sep 2017 13:21:32 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.230 
--- ncurses-6.0-20170909+/package/mingw-ncurses.nsi	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/package/mingw-ncurses.nsi	2017-09-10 17:21:32.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.230 2017/09/03 20:54:16 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.231 2017/09/10 17:21:32 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "0"
 !define VERSION_YYYY  "2017"
-!define VERSION_MMDD  "0909"
+!define VERSION_MMDD  "0916"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.0-20170909+/package/mingw-ncurses.spec	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/package/mingw-ncurses.spec	2017-09-10 17:21:32.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.0
-Release: 20170909
+Release: 20170916
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.0-20170909+/package/ncurses.spec	2017-09-03 20:54:16.000000000 +0000
+++ ncurses-6.0-20170916/package/ncurses.spec	2017-09-10 17:21:32.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.0
-Release: 20170909
+Release: 20170916
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: test/filter.c
Prereq:  1.30 
--- ncurses-6.0-20170909+/test/filter.c	2017-09-08 22:34:05.000000000 +0000
+++ ncurses-6.0-20170916/test/filter.c	2017-09-10 19:49:55.000000000 +0000
@@ -29,7 +29,7 @@
 /*
  * Author:  Thomas E. Dickey 1998
  *
- * $Id: filter.c,v 1.30 2017/09/08 22:34:05 tom Exp $
+ * $Id: filter.c,v 1.31 2017/09/10 19:49:55 tom Exp $
  *
  * An example of the 'filter()' function in ncurses, this program prompts
  * for commands and executes them (like a command shell).  It illustrates
@@ -253,7 +253,7 @@
     }
     attroff(underline);
     attroff(A_BOLD);
-    printw("\n");
+    refresh();
 
     return code;
 }
